<html>

<head>
    <title>(doc) Permissions</title>
    <link rel="stylesheet" href="include_web/css/bootstrap.min.css">
    <script src="include_web/js/bootstrap.min.js"></script>
    <script src="include_web/js/jquery-3.3.1.slim.min.js"></script>
    <script src="include_web/js/popper.min.js"></script>

    <!-- Permission Table generator -->
    <script>
        function buildHtmlTable() {
            // read JSON File
            let jsonRaw = "";
            let rawFile = new XMLHttpRequest();
            rawFile.open("GET", "permissions.json", false);
            rawFile.onreadystatechange = function () {
                if (rawFile.readyState === 4) {
                    if (rawFile.status === 200 || rawFile.status === 0) {
                        jsonRaw = rawFile.responseText;
                    }
                }
            };
            rawFile.send(null);

            let json = JSON.parse(jsonRaw);

            // EXTRACT VALUE FOR HTML HEADER.
            // ('Book ID', 'Book Name', 'Category' and 'Price')
            let col = [];
            for (let i = 0; i < json.length; i++) {
                for (let key in json[i]) {
                    if (col.indexOf(key) === -1) {
                        col.push(key);
                    }
                }
            }

            // CREATE DYNAMIC TABLE.
            let table = document.createElement("table");
            table.className = "table table-bordered";
            table.id = "myTable";

            // CREATE HTML TABLE HEADER ROW USING THE EXTRACTED HEADERS ABOVE.

            let tr = table.insertRow(-1);                   // TABLE ROW.

            for (let i = 0; i < col.length; i++) {
                let th = document.createElement("th");      // TABLE HEADER.
                tr.className = "thead-dark";

                th.innerHTML = col[i];
                tr.appendChild(th);
            }

            // ADD JSON DATA TO THE TABLE AS ROWS.
            for (let i = 0; i < json.length; i++) {

                tr = table.insertRow(-1);
                tr.className = "table-striped";

                for (let j = 0; j < col.length; j++) {
                    let tabCell = tr.insertCell(-1);
                    tabCell.innerHTML = json[i][col[j]];
                }
            }

            // FINALLY ADD THE NEWLY CREATED TABLE WITH JSON DATA TO A CONTAINER.
            let divContainer = document.getElementById("showData");
            divContainer.innerHTML = "";
            divContainer.appendChild(table);
        }
    </script>

    <!-- Costume CSS Style -->
    <style>
        #searchInput {
            background: url('include_web/css/searchicon.png') no-repeat 10px 12px;
            width: 100%; /* Full-width */
            font-size: 16px; /* Increase font-size */
            padding: 12px 20px 12px 40px; /* Add some padding */
            border: 1px solid #ddd; /* Add a grey border */
            margin-bottom: 12px; /* Add some space below the input */
        }

        #myTable {
            border-collapse: collapse; /* Collapse borders */
            width: 100%; /* Full-width */
            border: 1px solid #ddd; /* Add a grey border */
            font-size: 18px; /* Increase font-size */
        }

        #myTable th, #myTable td {
            text-align: left; /* Left-align text */
            padding: 12px; /* Add padding */
        }

        #myTable tr {
            /* Add a bottom border to all table rows */
            border-bottom: 1px solid #ddd;
        }

        #myTable tr.header, #myTable tr:hover {
            /* Add a grey background color to the table header and on hover */
            background-color: #f1f1f1;
        }
    </style>
</head>

<body onLoad="buildHtmlTable()">
<div class="container">
    <input type="text" id="searchInput" onkeyup="search()" placeholder="Search for Permissions..">
    <br><br>


    <div id="showData" class="container"></div>
</div>

<!-- JS Scripts -->
<script>
    function search() {
        // Declare variables
        let input, filter, table, tr, td, i;
        input = document.getElementById("searchInput");
        filter = input.value.toUpperCase();
        table = document.getElementById("myTable");
        tr = table.getElementsByTagName("tr");

        // Loop through all table rows, and hide those who don't match the search query
        for (i = 0; i < tr.length; i++) {
            td = tr[i].getElementsByTagName("td")[0];
            if (td) {
                if (td.innerHTML.toUpperCase().indexOf(filter) > -1) {
                    tr[i].style.display = "";
                } else {
                    tr[i].style.display = "none";
                }
            }

            td = tr[i].getElementsByTagName("td")[1];
            if (td) {
                if (td.innerHTML.toUpperCase().indexOf(filter) > -1) {
                    tr[i].style.display = "";
                } else {
                    tr[i].style.display = "none";
                }
            }
        }
    }
</script>
</body>

</html>
